import textwrap
import requests
import json

url= "https://wiremock.uat.10.88.139.127.nip.io/__admin/mappings"
https_proxy = "https://smtcig000004.cnrd.corpintra.net:3128"
proxyDict = {"https" : ""}


def upload_mapping(reqBody):
    requests.packages.urllib3.disable_warnings(requests.packages.urllib3.exceptions.InsecureRequestWarning)

    # delete old mapping
    payload = {
        'request': reqBody['request']
    }
    requests.post(url + "/remove", data=json.dumps(payload), verify=False, proxies=proxyDict)

    # add new mapping
    res = requests.post(url, data=json.dumps(reqBody), verify=False, proxies=proxyDict)
    #res = requests.post(url, data=json.dumps(reqBody), verify=False, proxies=proxyDict, hooks={'response': print_roundtrip})

    if res.status_code == 201:
        return True
    else:
        return False


def load_mock_file(filePath):
    with open(filePath, 'r+', encoding='utf-8') as mockFile:
            jsonEntity = json.load(mockFile)
            return jsonEntity


def upload_mapping_from_file(filePath):
    reqBody = load_mock_file(filePath)
    if upload_mapping(reqBody):
        print("Upload successful:", filePath)
    else:
        print("Upload failed:", filePath)


def upload_mapping_from_template(templateFilePath):
    reqBody = load_mock_file(templateFilePath)
    bodyFilePath = templateFilePath.replace("_template", "_body")
    reqBody['response']['body'] = json.dumps(load_mock_file(bodyFilePath))
    if upload_mapping(reqBody):
        print('Upload successful:\n   {templateFilePath}\n   {bodyFilePath}'.format(templateFilePath = templateFilePath, bodyFilePath = bodyFilePath))
    else:
        print('Upload failed:\n   {templateFilePath}\n   {bodyFilePath}'.format(templateFilePath = templateFilePath, bodyFilePath = bodyFilePath))


def print_roundtrip(response, *args, **kwargs):
    format_headers = lambda d: '\n'.join(f'{k}: {v}' for k, v in d.items())
    print(textwrap.dedent('''
        ---------------- request ----------------
        {req.method} {req.url}
        {reqhdrs}

        {req.body}

        ---------------- response ----------------
        {res.status_code} {res.reason} {res.url}
        {reshdrs}

        {res.text}
    ''').format(
        req = response.request,
        res = response,
        reqhdrs = format_headers(response.request.headers),
        reshdrs = format_headers(response.headers),
    ))